<?php

class Marketing_Mergado_Block_Adminhtml_Mergado_Edit_Form extends Mage_Adminhtml_Block_Widget_Form {

    protected function _prepareForm() {

        $section = Mage::registry('mergado_section');

        $mergadoXml = Mage::getConfig()
                ->loadModulesConfiguration('mergado.xml')
                ->getNode('mergado/' . $section);


        $form = new Varien_Data_Form(array(
            'id' => 'edit_form',
            'action' => $this->getUrl('*/*/save', array(
                '_current' => true,
                'continue' => 0,
            )),
            ///*, array('id' => $this->getRequest()->getParam('id'))*/),
            'method' => 'post',
            'enctype' => 'multipart/form-data'
        ));

        foreach ($mergadoXml->groups->children() as $groupCode => $group) {

            $fieldset = $form->addFieldset($groupCode, array('legend' => Mage::helper('mergado')->__((string) $group->label), 'comment' => Mage::helper('mergado')->__((string) $group->comment)));

            if ($group->block) {
                $fieldset->addField('note', 'note', array(
                    'text' => $this->getLayout()->createBlock((string) $group->block['type'])->toHtml(),
                        //'after_element_html'=>'*<b>*</b>*'
                ));
            }

            //pro sekci locale se fieldy generuji dynamicky ze stores, ne z xml
            if ($groupCode == 'locale') {
                $this->addLocale($fieldset);
                continue;
            }
            //echo $group->label.'<br/>';
            $children = [];
            foreach ($group->fields->children() as $fieldCode => $element) {
                if ((int) $element->multistore) {
                    foreach (Mage::helper('mergado')->getStores() as $store) {
                        $el = clone $element;
                        $el->label = $this->__((string) $element->label) . ' ' . $store->getName();
                        $children[$fieldCode . '_' . $store->getId()] = $el;
                    }
                } else {
                    $children[$fieldCode] = $element;
                }
            }

            foreach ($children /* $group->fields->children() */ as $fieldCode => $element) {

                $fieldComment = $this->__((string) $element->comment);

                if ($fieldCode == 'logging_enabled') {
                    $fieldComment = '<a href="' . Mage::helper('mergado')->getLogUrl() . '" target="_blank">log</a>';
                    //$fieldComment .= var_export(Mage::getStoreConfig('mergado'), 1);
                }

                $field = $fieldset->addField($groupCode . '_' . $fieldCode, $element->frontend_type, array(
                    'name' => $groupCode . '[' . $fieldCode . ']',
                    'label' => $this->__((string) $element->label),
                    'comment' => 'comment' . $element->comment,
                    'tooltip' => 'tooltip' . $element->tooltip,
                    'hint' => 'hint' . $element->hint,
                    'after_element_html' => '<small>' . $fieldComment . '</small>',
                    'value' => Mage::getStoreConfig('mergado/' . $groupCode . '/' . $fieldCode),
                    //'inherit'               => $inherit,
                    //'class'                 => $element->frontend_class . $sharedClass . $requiresClass,
                    'field_config' => $element,
                        /* 'scope'                 => $this->getScope(),
                          'scope_id'              => $this->getScopeId(),
                          'scope_label'           => $this->getScopeLabel($element),
                          'can_use_default_value' => $this->canUseDefaultValue((int)$element->show_in_default),
                          'can_use_website_value' => $this->canUseWebsiteValue((int)$element->show_in_website), */
                ));

                $fieldType = (string) $element->frontend_type;
                if ($element->source_model) {
                    // determine callback for the source model
                    $factoryName = (string) $element->source_model;
                    $method = false;
                    if (preg_match('/^([^:]+?)::([^:]+?)$/', $factoryName, $matches)) {
                        array_shift($matches);
                        list($factoryName, $method) = array_values($matches);
                    }

                    $sourceModel = Mage::getSingleton($factoryName);
                    if ($sourceModel instanceof Varien_Object) {
                        $sourceModel->setPath($path);
                    }
                    if ($method) {
                        if ($fieldType == 'multiselect') {
                            $optionArray = $sourceModel->$method();
                        } else {
                            $optionArray = array();
                            foreach ($sourceModel->$method() as $value => $label) {
                                $optionArray[] = array('label' => $label, 'value' => $value);
                            }
                        }
                    } else {
                        $optionArray = $sourceModel->toOptionArray($fieldType == 'multiselect');
                    }
                    $field->setValues($optionArray);
                }
            }
        }

        $form->setUseContainer(true);
        $this->setForm($form);

        return parent::_prepareForm();
    }

    protected function addLocale($fieldset) {
        $groupCode = 'locale';
        $optionArray = Mage::getSingleton('adminhtml/system_config_source_yesno')->toOptionArray();
        foreach (Mage::helper('mergado')->getStores() as $store) {
            foreach (Mage::helper('mergado')->getCurrencies() as $currency) {
                $fieldCode = /* 'store_'. */$store->getId() . '_' . $currency/* ->getCode() */;
                $field = $fieldset->addField($groupCode . '_' . $fieldCode, 'select', array(
                    'name' => $groupCode . '[' . $fieldCode . ']',
                    'label' => $this->__($store->getName() . ' - ' . $currency),
                    'value' => Mage::getStoreConfig('mergado/' . $groupCode . '/' . $fieldCode),
                ));

                $field->setValues($optionArray);
            }
        }
    }

}
