<?php  

class Marketing_Mergado_Block_Feed extends Mage_Core_Block_Template {
  
    public function __construct()
    {
        parent::__construct();
        $this->setTemplate('mergado/feed/default.phtml');
    }
    
    public function getGeneratorName(){
        $version = Mage::getConfig()->getNode()->modules->Marketing_Mergado->version;
        return 'mergado.magento.marketingpack.'.preg_replace('~_[^_]+$~','', str_replace('.','_', $version));
    }
    
    protected function _beforeToHtml(){
        return '<?xml version="1.0" encoding="utf-8"?>';
    }
    
    public function currency($price, $currency = null){
        if (!$currency){
          $currency = $this->getCurrency();
        }
        $currentCurrencyCode = Mage::app()->getStore()->getCurrentCurrencyCode();
        
        return Mage::helper('directory')->currencyConvert($price, $currentCurrencyCode, $currency);
    } 
    
    public function getProducts(){
        return Mage::getModel('catalog/product')->getCollection()
                ->addAttributeToFilter('status',1)
                ->addAttributeToFilter('visibility', ['in'=>explode(',', Mage::getStoreConfig('mergado/export_setting/visibility'))]);
    }
    
    public function getProductsWithQty(){
        $collection = Mage::getModel('catalog/product')
                                                 ->getCollection()
                                                 //->addAttributeTo
                                                 //->addAttributeToSelect('*')
                                                 ->joinField('qty',
                                                        'cataloginventory/stock_item',
                                                        'qty',
                                                        'product_id=entity_id',
                                                        '{{table}}.stock_id=1',
                                                        'left')
                                                    ->addAttributeToFilter('qty', array("gt" => 0));
        return $collection;
    }
    
    

    public function getProductsWithCost(){
        $collection = Mage::getModel('catalog/product')
                                                 ->getCollection()
                                                 ->addAttributeToSelect('cost')
                                                 ->addAttributeToFilter('cost', array("gt" => 0));
        return $collection;
    }    
    
}