<?php
class Marketing_Mergado_Helper_Data extends Mage_Core_Helper_Abstract
{
    protected $data = [];
    
    public function getStores(){
        return Mage::app()->getStores();
    }
    
    public function log($message, $level = null){
        if (Mage::getStoreConfig('mergado/suppport_setting/logging_enabled')){
            //Mage::log($message, $level, '../../mergado.log');
            Mage::log($message, $level, $this->getLogPath(false));
        }
    }

    public function getLogPath($absolute = true){
         $hash = $this->getHash('log');
         return ($absolute ? Mage::getBaseDir('media') : '..'.DS.'..'.DS.'media') . DS . 'mergado' . DS . 'log-' . $hash . '.log'; 
    }    

    public function getLogUrl(){
        $hash = $this->getHash('log');
        return Mage::getBaseUrl('media').'mergado'.DS.'log-'.$hash.'.log'; 
    }    
    
    public function getLogHash(){
        //return md5''
    }
    
    public function getCurrencies(){
        
        /*$countryList = Mage::getModel('directory/currency')->getResourceCollection()
                                                  ->loadByStore()
                                                  ->toOptionArray(true);
        var_dump($countryList);*/
        $currencies = [];
        foreach(Mage::getModel('core/config_data')->getCollection()->addFieldToFilter('path','currency/options/allow')
              as $cur){
                  //echo '['.$cur->getValue().']<br/>';
                  $currencies = array_merge($currencies, explode(',', $cur->getValue()));
              }
        //var_dump($currencies);      
        $currencies = array_unique($currencies);
        
        return $currencies;
        
        /*var_dump($CurrencyCode);                                                        
        return ['CZK', 'EUR'];*/
    }
    
    protected function getHash($string){
       //echo Mage::getBaseUrl('web');
       return substr(md5(Mage::getBaseUrl('web').$string), 0, 10);
    }
    
    public function getFeedPath($store, $currency){
         $hash = $this->getHash($store . $currency);
         return Mage::getBaseDir('media').DS.'mergado'.DS.'mergado-'.$store.'-'.$currency.'-'.$hash.'.xml'; 
    }

    public function getFeedUrl($store, $currency){
        $hash = $this->getHash($store . $currency);
        return Mage::getBaseUrl('media').'mergado/mergado-'.$store.'-'.$currency.'-'.$hash.'.xml'; 
    }

    public function getAvailabilityFeedPath(){
        $hash = $this->getHash('avail');
        return Mage::getBaseDir('media').DS.'mergado'.DS.'mergado-availability-'.$hash.'.xml'; 
    }    

    public function getAvailabilityFeedUrl(){
        $hash = $this->getHash('avail');
        return Mage::getBaseUrl('media').'mergado/mergado-availability-'.$hash.'.xml'; 
    }
    
    public function getStaticFeedPath(){
        $hash = $this->getHash('static');
        return Mage::getBaseDir('media').DS.'mergado'.DS.'mergado-static-'.$hash.'.xml'; 
    }    

    public function getStaticFeedUrl(){
        $hash = $this->getHash('static');
        return Mage::getBaseUrl('media').'mergado/mergado-static-'.$hash.'.xml'; 
    }
    
    public function set($key, $value){
        $this->data[$key] = $value;
    }
    
    public function get($key){
        if (isset($this->data[$key])){
            return $this->data[$key];
        }
        return null;
    }
    
    public function getCategoryText($category){
        $parentPath = '';
        if ($category->getLevel()>2) {
            $parentPath = $this->getCategoryText($category->getParentCategory()).' | ';
        }
        return $parentPath.$category->getName();
    }
}
	 