<?php 

class Marketing_Mergado_Model_Observer{
    public function addSuccessScripts(Varien_Event_Observer $observer)
    {
        $orderIds = $observer->getEvent()->getOrderIds();
        if (empty($orderIds) || !is_array($orderIds)) {
            return;
        }
        
        $order = Mage::getSingleton('sales/order');
        $order->load($orderIds[0]);
        
        $layout = Mage::app()->getFrontController()->getAction()->getLayout();
        $block = $layout->createBlock('core/template')
                ->setTemplate('mergado/success_scripts.phtml')
                ->setOrderIds($orderIds)
                ->setOrder($order);
        $layout->getBlock('content')->append($block);
    }    
    
    public function processProducts(Varien_Event_Observer $observer){
        //echo 'KAT'.$observer->getCategoryId();
        if ($observer->getCategoryId()){
            Mage::helper('mergado')->set('current_products',$observer->getCollection());
        }
    }
    
    public function productAdded(Varien_Event_Observer $observer){
        $product = $observer->getEvent()->getProduct();
        Mage::getSingleton("checkout/session")->setMergadoLastAddedProductId($product->getId());
    }
    
}